<?php
/**
 * jDiction library entry point
 *
 * @package jDiction
 * @link http://joomla.itronic.at
 * @copyright	Copyright (C) 2011 ITronic Harald Leithner. All rights reserved.
 * @license GNU General Public License v3
 * @version 1.6.1 (18)
 *
 * This file is part of jDiction.
 *
 * jDiction is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 *
 * jDiction is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with jDiction.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
defined('_JEXEC') or die;

abstract class jDictionViewXmlHelper {

	public static function createTranslationViews() {

		$db = JFactory::getDbo();
		$defaultLanguage = JComponentHelper::getParams('com_languages')->get('site', 'en-GB');
		$targetTables = array();
		$jd = jdiction::getInstance();
		$tables = $jd->getTable();

		foreach($tables as $table) {
			$component = $jd->getComponentByTable($table->name);
			/* @var $form SimpleXMLElement */
			//$form = current($component)->form;
			//$form->xpath('')
			foreach($component as $section) {
				$fields = $jd->getFieldsByView($table->component, $section->name);
				foreach($fields as $field) {
					$fieldTable = isset($field->table) ? $field->table : $table->name;
					$fieldName = $field->name;

					if (isset($field->multifield) && is_array($field->multifield)) {
						foreach($field->multifield as $fieldName) {
							$targetTables[$fieldTable][$fieldName] = $fieldName;
						}
					} else {
						if (isset($field->group) && $field->group != '') {

							if (isset($field->jd_fields_attr) && isset($field->jd_fields_attr->table)) {
								$fieldTable = $field->jd_fields_attr->table;
							} else {
								//printpre($field, $table->component, $section->name, $fields);
								continue; //ignore josn fields its handled by the old method
							}
						}
						$targetTables[$fieldTable][$fieldName] = $fieldName;
					}

				}
			}
		}


		foreach($targetTables as $targetTable=>$targetFields) {
			foreach($jd->getLanguages(true) as $lang) {

				$view = "#__jd_".$lang->lang_id."_".str_replace('#__', '', $targetTable);

				$query = "CREATE OR REPLACE ALGORITHM=UNDEFINED SQL SECURITY INVOKER VIEW ".$db->qn($view)."  AS  SELECT ";

				$columns = $db->getTableColumns($targetTable);
				foreach($columns as $column=>$type) {
					if (in_array($column, $targetFields)) {
						switch ($column) {
							case 'introtext':
								$query .= "IFNULL(
									IF(
										EXTRACTVALUE(`jds`.`value`,'count(/jDiction/articletext)') = 0, " . $db->qn('t1.' . $column) . ",
										SUBSTRING_INDEX(EXTRACTVALUE(`jds`.`value`,'/jDiction/articletext'), '<hr id=\"system-readmore\" />', 1)
								), " . $db->qn('t1.' . $column) . "
								) AS " . $db->qn($column) . ",";
								break;
							case 'fulltext':
								$query .= "IFNULL(
									IF(
										EXTRACTVALUE(`jds`.`value`,'count(/jDiction/articletext)') = 0, " . $db->qn('t1.' . $column) . ",
										IF(LOCATE('<hr id=\"system-readmore\" />', EXTRACTVALUE(`jds`.`value`,'/jDiction/articletext')) = 0, " . $db->qn('t1.' . $column) . ",
											SUBSTRING_INDEX(EXTRACTVALUE(`jds`.`value`,'/jDiction/articletext'), '<hr id=\"system-readmore\" />', -1)
										)
								), " . $db->qn('t1.' . $column) . "
								) AS " . $db->qn($column) . ",";
								break;
							default:
								$query .= "IFNULL(IF(EXTRACTVALUE(`jds`.`value`,'count(/jDiction/" . $column . ")') = 0 , " . $db->qn('t1.' . $column) . ", EXTRACTVALUE(`jds`.`value`,'/jDiction/" . $column . "')), " . $db->qn('t1.' . $column) . ") AS " . $db->qn($column) . ",";
						}
					} else {
						$query .= $db->qn('t1.'.$column).',';
					}

				}
				$query = rtrim($query,",");
				$query .= " FROM ".$db->qn($targetTable, 't1');
				$query .= " LEFT JOIN ".$db->qn('#__jd_store', 'jds').' ON '.$db->qn('t1.'.$tables[$targetTable]->key).' = '.$db->qn('jds.idReference');
				$query .= " AND (".$db->qn('jds.referenceTable').' = '.$db->q($targetTable). " AND ".$db->qn('jds.idLang').' = '.$db->q($lang->lang_id) . ")";

				// We skip default language after deleting maybe existing old views
				if ($lang->lang_code == $defaultLanguage) continue;

				$db->setQuery($query);

				$db->execute();
			}
		}
	}

}
